From 9f7ff2e3a619089a6ae6ff8cc83425e5c1f493e0 Mon Sep 17 00:00:00 2001
From: Adrian Taylor <adetaylor@chromium.org>
Date: Oct 13 2020 03:14:17 +0000
Subject: [PATCH 1046/2232] Switch to build-time squashing of 'new' method.


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 3cd94d1..9b4e120 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -1247,9 +1247,9 @@ fn write_unique_ptr_common(out: &mut OutFile, ty: &Type, types: &Types) {
     let can_construct_from_value = match ty {
         // Some aliases are to opaque types; some are to trivial types.
         // We can't know at code generation time, so we generate both C++
-        // and Rust side bindings for a "new" method anyway. But that
-        // Rust code will explode at runtime if anyone tries to call it on
-        // an opaque type.
+        // and Rust side bindings for a "new" method anyway. But the Rust
+        // code can't be called for Opaque types because the 'new'
+        // method is not implemented.
         Type::Ident(ident) => types.structs.contains_key(ident) || types.aliases.contains_key(ident),
         _ => false,
     };
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 4213b4d..4a4ec64 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -815,21 +815,12 @@ fn expand_unique_ptr(
     let link_drop = format!("{}drop", prefix);
 
     let new_method = if types.structs.contains_key(ident) || types.aliases.contains_key(ident) {
-        let trivial_assertion: Option<syn::Stmt> = if types.aliases.contains_key(ident) {
-            Some(parse_quote! {
-               < < #ident as :: cxx :: ExternType > :: Kind as :: cxx :: kind :: Kind > :: assert_trivial();
-            })
-        } else {
-            None
-        };
-
         Some(quote! {
             fn __new(mut value: Self) -> *mut ::std::ffi::c_void {
                 extern "C" {
                     #[link_name = #link_new]
                     fn __new(this: *mut *mut ::std::ffi::c_void, value: *mut #ident);
                 }
-                #trivial_assertion
                 let mut repr = ::std::ptr::null_mut::<::std::ffi::c_void>();
                 unsafe { __new(&mut repr, &mut value) }
                 repr
diff --git a/src/extern_type.rs b/src/extern_type.rs
index 45414c8..b9c5386 100644
--- a/src/extern_type.rs
+++ b/src/extern_type.rs
@@ -165,17 +165,9 @@ pub mod kind {
     /// indirection.
     pub enum Trivial {}
 
-    pub trait Kind: private::Sealed {
-        fn assert_trivial();
-    }
-    impl Kind for Opaque {
-        fn assert_trivial() {
-            panic!("Type not trivial");
-        }
-    }
-    impl Kind for Trivial {
-        fn assert_trivial() {}
-    }
+    pub trait Kind: private::Sealed {}
+    impl Kind for Opaque {}
+    impl Kind for Trivial {}
 }
 
 mod private {
diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index 477c716..4bb5d67 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -1,5 +1,7 @@
 use crate::cxx_string::CxxString;
 use crate::cxx_vector::{self, CxxVector, VectorElement};
+use crate::ExternType;
+use crate::kind::Trivial;
 use core::ffi::c_void;
 use core::fmt::{self, Debug, Display};
 use core::marker::PhantomData;
@@ -32,7 +34,9 @@ where
     }
 
     /// Allocates memory on the heap and makes a UniquePtr pointing to it.
-    pub fn new(value: T) -> Self {
+    pub fn new(value: T) -> Self
+    where
+    T: ExternType<Kind = Trivial> {
         UniquePtr {
             repr: T::__new(value),
             ty: PhantomData,
diff --git a/tests/ffi/extra.rs b/tests/ffi/extra.rs
index 6209702..a809ea4 100644
--- a/tests/ffi/extra.rs
+++ b/tests/ffi/extra.rs
@@ -12,14 +12,12 @@
 pub mod ffi2 {
     impl UniquePtr<D> {}
     impl UniquePtr<E> {}
-    impl UniquePtr<F> {}
 
     extern "C" {
         include!("tests/ffi/tests.h");
 
         type D = crate::other::D;
         type E = crate::other::E;
-        type F = crate::other::F;
 
         fn c_take_trivial_ptr(d: UniquePtr<D>);
         fn c_take_trivial_ref(d: &D);
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index f80cda7..b3c2330 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -14,25 +14,17 @@ mod other {
     use cxx::kind::{Opaque, Trivial};
     use cxx::{type_id, CxxString, ExternType};
 
-    // Trivial.
     #[repr(C)]
     pub struct D {
         pub d: u64,
     }
 
-    // Opaque, and has realistic complexity.
     #[repr(C)]
     pub struct E {
         e_str: CxxString,
         e: u64,
     }
 
-    // Opaque, but simple enough that bad code can try to create it.
-    #[repr(C)]
-    pub struct F {
-        pub f: u64,
-    }
-
     unsafe impl ExternType for D {
         type Id = type_id!("tests::D");
         type Kind = Trivial;
@@ -42,11 +34,6 @@ mod other {
         type Id = type_id!("tests::E");
         type Kind = Opaque;
     }
-
-    unsafe impl ExternType for F {
-        type Id = type_id!("tests::F");
-        type Kind = Opaque;
-    }
 }
 
 #[cxx::bridge(namespace = tests)]
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index ff1fbd3..b3f547e 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -37,10 +37,6 @@ struct E {
   std::string e_str;
 };
 
-struct F {
-  uint64_t f;
-};
-
 enum COwnedEnum {
   CVal1,
   CVal2,
diff --git a/tests/test.rs b/tests/test.rs
index 3ea02fa..b92eebf 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -207,7 +207,4 @@ fn test_extern_opaque() {
     let e = ffi2::c_return_opaque_ptr();
     check!(ffi2::c_take_opaque_ref(e.as_ref().unwrap()));
     check!(ffi2::c_take_opaque_ptr(e));
-    assert!(std::panic::catch_unwind(|| {
-        cxx::UniquePtr::new(ffi2::F { f: 42 })
-    }).is_err());
 }
diff --git a/tests/ui/unique_ptr_to_opaque.rs b/tests/ui/unique_ptr_to_opaque.rs
new file mode 100644
index 0000000..6f3bf8c
--- /dev/null
+++ b/tests/ui/unique_ptr_to_opaque.rs
@@ -0,0 +1,26 @@
+mod outside {
+    #[repr(C)]
+    pub struct C {
+        pub a: u8,
+    }
+    unsafe impl cxx::ExternType for C {
+        type Id = cxx::type_id!("C");
+        type Kind = cxx::kind::Opaque;
+    }
+}
+
+
+#[cxx::bridge]
+mod ffi {
+    impl UniquePtr<C> {}
+
+    extern "C" {
+        type C = crate::outside::C;
+    }
+
+    impl UniquePtr<C> {}
+}
+
+fn main() {
+    cxx::UniquePtr::new(outside::C { a: 4 } );
+}
diff --git a/tests/ui/unique_ptr_to_opaque.stderr b/tests/ui/unique_ptr_to_opaque.stderr
new file mode 100644
index 0000000..5525a05
--- /dev/null
+++ b/tests/ui/unique_ptr_to_opaque.stderr
@@ -0,0 +1,7 @@
+error[E0271]: type mismatch resolving `<outside::C as ExternType>::Kind == Trivial`
+  --> $DIR/unique_ptr_to_opaque.rs:25:5
+   |
+25 |     cxx::UniquePtr::new(outside::C { a: 4 } );
+   |     ^^^^^^^^^^^^^^^^^^^ expected enum `Trivial`, found enum `cxx::kind::Opaque`
+   |
+   = note: required by `UniquePtr::<T>::new`

